#ifndef Fl_RGBA_Button_H
#define Fl_RGBA_Button_H

#include <FL/Fl_Button.H>

class Fl_RGBA_Chooser;

class Fl_RGBA_Button : public Fl_Button {
protected:
  static void	generate_achip(void*, int, int, int, uchar*);
  Fl_RGBA_Chooser* rgba_chooser;
  Fl_Callback*	on_change_cb;
  void*		on_change_ud;
public:
  float		r, g, b, a;

  Fl_RGBA_Button(int x, int y, int w, int h, char const *t=0);
  ~Fl_RGBA_Button();

  void set_rgba(float, float, float, float a=1);
  void set_rgba(Fl_RGBA_Button* w);

  void spawn_chooser();
  void wipe_chooser();
  void on_change(Fl_Callback* cb, void* ud) { on_change_cb=cb; on_change_ud = ud; }
  Fl_Callback* on_change() { return on_change_cb; }
  void* on_change_data() { return on_change_ud; }
  static void default_cb(Fl_RGBA_Button* w, Fl_RGBA_Button* ud);

  virtual void draw();
};

#endif
