// $Header$
#include <FL/Fl_File_Name.H>
#include <FL/Fl_File_Dialog.H>

static char __jebo_[FL_MAX_PATH+200];
char*	Fl_File_Name::sBugFer = __jebo_;

//char*	Fl_File_Name::sBugFer = new char[FL_MAX_PATH+200];

int	Fl_File_Name::sBugRet = 0;

class _Finput_Dor_;

static void cb_fido_ok(Fl_Widget* w, _Finput_Dor_* fd);
static void cb_fido_cancel(Fl_Widget* w, _Finput_Dor_* fd);
static void cb_exit(Fl_Widget* w, Fl_Return_Button* rb) {
  rb->do_callback(); // Reroute doublicks to OK
}

class _Finput_Dor_ : public Fl_Window {
public:
  Fl_File_Dialog*	pFileDialog;
  Fl_Box*		pBox;
  Fl_Return_Button*	pOK;
  Fl_Button*		pCancel;
  Fl_File_Name*		curr_Fl_File_Name;

  _Finput_Dor_() : Fl_Window(472, 343) {
    pFileDialog = new Fl_File_Dialog(5, 5,"", Fl_File_Name::sBugFer, 0, 0, 0);
    pBox = new Fl_Box(208, 306, 56, 34);
    pOK = new Fl_Return_Button(244, 311, 220, 25, "Ok");
    pCancel = new Fl_Button(8, 311, 220, 25, "Cancel");

    pFileDialog->exit_callback((Fl_Callback*)cb_exit, pOK);
    pOK->callback((Fl_Callback*)cb_fido_ok, this);
    pCancel->callback((Fl_Callback*)cb_fido_cancel, this);

    resizable(pFileDialog);
    set_modal();
    end();
  }
  virtual int handle(int ev) {
    if(ev==FL_KEYBOARD) {
      if(Fl::event_key()==FL_Enter)  { pOK->do_callback(); return 1; }
      if(Fl::event_key()==FL_Escape) { pCancel->do_callback(); return 1; }
    }
    return Fl_Window::handle(ev);
  }
};

static _Finput_Dor_* FiDor = 0;

static void
cb_fido_ok(Fl_Widget* w, _Finput_Dor_* fd) {
  if(Fl_File_Name::sBugRet = fd->pFileDialog->getFilename(Fl_File_Name::sBugFer)) {
    fd->curr_Fl_File_Name->value(Fl_File_Name::sBugFer);
    fd->curr_Fl_File_Name->position(fd->curr_Fl_File_Name->size());
    fd->curr_Fl_File_Name->do_callback();
  }
  fd->curr_Fl_File_Name = 0;
  fd->hide();
}
static void
cb_fido_cancel(Fl_Widget* w, _Finput_Dor_* fd) {
  fd->curr_Fl_File_Name = 0;
  fd->hide();
}

int
Fl_File_Name::handle(int ev) {
  if(ev==FL_PUSH && Fl::event_button() == 3) return 1;
  if(ev==FL_RELEASE && Fl::event_button() == 3) {
    if(FiDor==0) FiDor = new _Finput_Dor_;
    FiDor->label(label());
    FiDor->pFileDialog->input_file.setFilename(value());
    FiDor->curr_Fl_File_Name = this;
    FiDor->show();
    redraw();
    return 1;
  }
  return Fl_Input::handle(ev);
}
