// Copyright (C) 1999-2002, Matevz Tadel.
// This file is part of fltk-mt. License: GNU LGPL version 2.

#include <FL/Fl_TopTitled_ScrollPack.H>

void Fl_TopTitled_ScrollPack::_build() {
  mScroll = new Fl_Scroll(0, 0, 1, 1);
  mPack = new Fl_Pack(0, 0, 1, 1);
  mPack->type(FL_VERTICAL);
  mPack->end();
  //mScroll->resizable(mPack);
  mScroll->end();
  resizable(mScroll);
}

Fl_TopTitled_ScrollPack::
Fl_TopTitled_ScrollPack(const char* t) :
  Fl_Window(1, 1, t),
  Fl_SWM_Client()
{
  _build();
}

Fl_TopTitled_ScrollPack::
Fl_TopTitled_ScrollPack(int h_top, int w, int h, const char* t=0) :
  Fl_Window(1, 1, t),
  Fl_SWM_Client()
{
  _build();
  partition(h_top, w, h);
}

void
Fl_TopTitled_ScrollPack::partition(int h_top, int w, int h) {
  mScroll->Fl_Widget::resize(0, h_top, w, h-h_top);
  mScroll->scrollbar.resize(w-2, 2, 2, h-2-h_top);
  mScroll->hscrollbar.resize(0,0, w-2, 1);
  mPack->resize(0, h_top, w-2, 1);
  Fl_Widget::resize(x(),y(),w,h);
  redraw();
}
