#include <FL/Fl_MC_Widget.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Light_Button.H>
#include <FL/Fl_Window.H>
#include <FL/Fl.H>

#include <stdio.h>
#include <iostream>

class XWin;
void test_cb(Fl_Widget*, Fl_MEVT::MEvent_e, XWin*, int);
void main_cb(Fl_Widget*, XWin*);

class XWin : public Fl_Window {
  lFl_MEVT_t				mMCTs;
  Fl_MC_Widget<Fl_Button>*		bAlfa;
  Fl_MC_Widget<Fl_Check_Button>*	bBeta;
  Fl_MC_Widget<Fl_Light_Button>*	bGamma;
public:
  XWin() : Fl_Window(230, 34, "XWin") {
mMCTs.push_back(
Fl_MEVT(Fl_MEVT::ME_push|Fl_MEVT::ME_release|Fl_MEVT::ME_drag,
	FL_RIGHT_MOUSE, 0, Fl_MEVT::MM_any,
	(Fl_MEVT::callback_f*)test_cb, 1, fl_color_cube(1,3,2)));
mMCTs.push_back(
Fl_MEVT(Fl_MEVT::ME_push|Fl_MEVT::ME_release|Fl_MEVT::ME_alldrags,
	FL_MIDDLE_MOUSE, FL_SHIFT, Fl_MEVT::MM_all,
	(Fl_MEVT::callback_f*)test_cb, 2, fl_color_cube(2,2,3)));
//mMCTs.push_back(
//Fl_MEVT(FL_DRAG, FL_RIGHT_MOUSE, 0, Fl_MEVT::MM_any,
//	      (Fl_MEVT::callback_f*)test_cb, 2));
//mMCTs.push_back(
//Fl_MEVT(FL_RELEASE, FL_RIGHT_MOUSE, 0, Fl_MEVT::MM_any,
//	      (Fl_MEVT::callback_f*)test_cb, 0));

    bAlfa = new Fl_MC_Widget<Fl_Button>(2,2,66,30,"Alfa");
    bAlfa->setMCs(&mMCTs, this);
    bAlfa->callback((Fl_Callback*)main_cb, this);
    bBeta = new Fl_MC_Widget<Fl_Check_Button>(70,2,66,30,"Beta");
    bBeta->type(FL_TOGGLE_BUTTON);
    bBeta->setMCs(&mMCTs, this);
    bGamma = new Fl_MC_Widget<Fl_Light_Button>(140,2,86,30,"Gamma");
    bGamma->setMCs(&mMCTs, this);
    end();
  }
};

void
test_cb(Fl_Widget* w, Fl_MEVT::MEvent_e e, XWin* u, int t) {
  cout <<"test_cb wlab="<< w->label() <<", mevt="<< e
       <<", type="<< t <<endl;
}

void
main_cb(Fl_Widget* w, XWin* o) {
  cout <<"main_cb wlab="<< w->label() <<endl;
}

/**************************************************************************/

int
main() {
  // test
  XWin x;
  x.show();
  Fl::run();
}
