#include <stdio.h>
#include <stdlib.h>

#include <FL/Fl.H>
#include <FL/Fl_SWM.H>
#include <FL/Fl_RGBA_Button.H>
#include <FL/Fl_RGBA_Chooser.H>

class Foo : public Fl_Window, public Fl_SWM_Client {
  Fl_RGBA_Button* rgba_b;
public:
  Foo() : Fl_Window(10,4,"FooWin"), Fl_SWM_Client() {
    rgba_b = new Fl_RGBA_Button(1,1,8,2,"C");
    rgba_b->on_change((Fl_Callback*)def_cb, this);
  }

  static void def_cb(Fl_RGBA_Button* b, Foo* f) {
    printf("Yoohoo ... %s changed: %5.3f %5.3f %5.3f %5.3f\n",
	   b->label(), b->r, b->g, b->b, b->a);
  }
};

/**************************************************************************/

main(int argc, char** argv) {
  int fs = (argc > 1) ? atoi(argv[1]) : 14;
  bool swmp = (fs > 0);
  Fl_Scaled_Windows_Manager* swm;
  if(swmp) { swm = new Fl_Scaled_Windows_Manager(fs); swm->Show(); }
  Foo f;
  if(swmp) {
    swm->AdoptWindow(&f);
  } else {
    Fl_Scaled_Windows_Manager::ResizeGroup(&f, 1,1, 8,20,14);
  }
  f.show();

  Fl::run();
}
